Skip to content
Everruns
Search
Ctrl
K
Cancel
Recent
Suggested
Run an agent
Zero-to-running starter tutorial
Deploy with Docker Compose
The whole platform in one command
Capabilities catalog
Every built-in capability and its tools
API reference
OpenAPI reference for every endpoint
Event reference
Every event type and its payload
Environment variables
Configure the control plane and workers
GitHub
Select theme
Dark
Light
Auto
Start here
Framework
Platform
Reference
Menu
Start here
Framework
Platform
Reference
0
Start here
Choose how you run Everruns
Self-hosted: Docker Compose
Everruns Cloud
Concepts
Use in AI Tools
Tutorials
Run an Agent
Build your first agent
1
Start
Overview
Quickstart
Architecture
Upgrade Notes
Core APIs
Agents and Tools
File-based Agents
Agent Format Reference
Models and Providers
Direct Calls and Decisions
Sessions
Events and Cancellation
Observability
Workspaces and Environments
Lifecycle Hooks
Answer Agent Questions
Session Work and Wakes
Extend
Advanced Capabilities
Capability Integrations
Portable vs Hosted
Agent Blueprints
Custom Backends
Testing and Simulation
Expose and deploy
Deploy a Framework App
Move to Platform or Cloud
Serve (experimental)
Serve AG-UI
A2A
Serve on AgentCore (experimental)
Serve on celld (experimental)
Examples
Overview
Support Agent
Everruns Support Agent
Coding Review Agent
Research Agent
Incident Commander Agent
Bashkit Repo Agent
Host Shell Agent
Foreman
2
Overview
Architecture
Physical Architecture
Features
A2A
Agent Checks
Agent Triggers
Agent Versions
Capabilities
Channels
ChatGPT plan
CLI
Environments
Evals
Events
Harnesses
MCP
URL elicitation
Agent and User Memory
SDK
Session Participants
Agent Skills
Management UI
Budgets
Network Access Control
How-to guides
How-to guides
Automate with the CLI
Build a foreman agent
Complete a URL elicitation over the API
Customize a harness
Define agents as files
Enforce a budget
Equip an agent with tools
Give an agent web access
Handle errors and cancel turns
Migrate between LLM providers
Orchestrate multi-agent pipelines
Package and publish an agent skill
Publish an Agent to Slack
Set up review and security agents
Share knowledge with Open Knowledge Format (OKF)
Stream events
Summarize GitHub Pull Requests
Use AGENTS.md for project instructions
Explanation
Explanation
The agentic loop
Durable execution
Events as the primary store
Context Compaction
Tool Output Pipeline
Operations (self-hosted)
Environment Variables
Admin Container
Request Signing
Runbooks
Authentication
Durable Execution Engine Setup
Encryption Key Rotation
Migration 144 Fails on Duplicate Platform Chat Starters
Virtual User Cutover
3
Event Reference
ID Schema
Harnesses
Overview
Base Harness
Bashkit Worker Harness
Conversation Harness
Data Analyst Harness
Generic Harness (deprecated)
Platform Chat Agent
Worker Harness
Worker Base Harness
Capabilities
Overview
Core
File System
Read Tools
Bashkit Shell
Host Shell
Session
Session Storage
Web Fetch
Current Time
Message Metadata
Ask User
Task Management
Schedules
Auto-Continue After Usage Limit
Sub Agents
AGENTS.md
Agent Skills
Sandboxes
Sandbox Fleet
Daytona
E2B
Container Sandbox
Browser
Browserless
Data
SQL Database
Retrieval Citations
Citation Verification
Memory
Knowledge Base
Knowledge Index
Data Knowledge
Media
OpenAI Image Generation
Tools
OpenAI Server Tools
OpenRouter Server Tools
Integrations
GitHub
GitHub Scout
Slack
Platform
Platform
Optimization
Infinity Context
Tool Search
Budgeting
Self-Budget
Parallel Tool Calls
Prompt Caching
Safety
Guardrails
Tool Approval
Prompt Canary Guardrail
Tool Call Repair
Soft Approval
Tool Loop Detection
Automation
User Hooks
Integrations
Overview
Sandboxes & execution
Cursor
Credentials
Secure MCP Credentials
Providers
Overview
Anthropic
Azure OpenAI
AWS Bedrock
Cloudflare AI Gateway
Fireworks AI
Google Gemini
Microsoft MAI
Meta Model API
OpenAI
OpenRouter
Vercel AI Gateway
Observability
Observability
OpenTelemetry
Braintrust
Experimental (dev grade)
A2A Agent Delegation
Agent Handoff
ARD
Brave Search
Computer Use
Docker Container
DuckDuckGo
Parallel
Sprites
TypeSafe
API Reference
Overview
agents
Overview
GET /v1/agents - List all active agents
POST /v1/agents - Create a new agent
POST /v1/agents/analyze - Run advisory checks against an agent shape
GET /v1/agents/check-name
GET /v1/agents/config
Generate a semantic diff against an existing agent without mutation.
POST /v1/agents/import - Import agent from file or built-in example
POST /v1/agents/preview - Preview the final agent shape with capabilities applied
Validate an agent package and its destination dependencies without mutation.
GET /v1/agents/{agent_id} - Get agent by ID or name
PUT /v1/agents/{agent_id} - Create or update agent (upsert)
DELETE /v1/agents/{agent_id} - Archive agent
PATCH /v1/agents/{agent_id} - Update agent
PUT /v1/agents/{agent_id}/avatar - Upload the agent's avatar
DELETE /v1/agents/{agent_id}/avatar - Remove the agent's avatar
POST /v1/agents/{agent_id}/copy - Copy an agent
list_credentials
create_credential_binding
set_credential_value
delete_credential_binding
GET /v1/agents/{agent_id}/export - Export agent in Markdown format with YAML front matter
POST /v1/agents/{agent_id}/exposures/resume - Let live endpoints serve again
POST /v1/agents/{agent_id}/exposures/suspend - Take every endpoint offline
GET /v1/agents/{agent_id}/health-checks - List recent health check runs
POST /v1/agents/{agent_id}/health-checks - Trigger a behavioral health check
GET /v1/agents/{agent_id}/health-checks/latest - Latest run + stale flag
GET /v1/agents/{agent_id}/health-checks/{run_id} - Get a health check run
list_agent_mcp_attachments
revoke_agent_mcp_connection
GET /v1/agents/{agent_id}/stats - Get aggregate usage stats for an agent
GET /v1/agents/{agent_id}/versions - List saved agent versions
POST /v1/agents/{agent_id}/versions - Save the current agent configuration as a version
POST /v1/agents/{agent_id}/versions/default - Set the default version for an agent
GET /v1/agents/{agent_id}/versions/{from_version_id}/diff/{to_version_id} - Diff two agent versions
POST /v1/agents/{agent_id}/versions/{version_id}/fork - Create a new agent from a saved version
POST /v1/agents/{agent_id}/versions/{version_id}/rollback - Restore an agent from a saved version
GET /v1/avatars/{avatar_id}/{variant} - Avatar image
sessions
Overview
GET /v1/sessions - List sessions in organization
POST /v1/sessions - Create a new session
GET /v1/sessions/facets - Facet counts and masthead metrics
Open the current user's permanent platform conversation, creating it only when absent.
GET /v1/sessions/stats - Get session counts by status
GET /v1/sessions/{session_id} - Get session
DELETE /v1/sessions/{session_id} - Delete session
PATCH /v1/sessions/{session_id} - Update session
PUT /v1/sessions/{session_id}/archive - Archive session
DELETE /v1/sessions/{session_id}/archive - Restore an archived session
POST /v1/sessions/{session_id}/cancel - Cancel current turn
GET /v1/sessions/{session_id}/context-report - Latest context breakdown
Export session messages as a JSONL file (default) or as an ATIF trajectory
POST /v1/sessions/{session_id}/fork - Fork a session into an independent copy
POST /v1/sessions/{session_id}/mcp-elicitation-consent
GET /v1/sessions/{session_id}/participants - List session participants
POST /v1/sessions/{session_id}/participants - Add a session participant
DELETE /v1/sessions/{session_id}/participants/{participant_id} - Leave a participant
PUT /v1/sessions/{session_id}/pin - Pin session for current user
DELETE /v1/sessions/{session_id}/pin - Unpin session for current user
POST /v1/sessions/{session_id}/question-answers
GET /v1/sessions/{session_id}/resolved-model - Resolve the session's active model
POST /v1/sessions/{session_id}/tool-approvals
POST /v1/sessions/{session_id}/tool-results - Submit client-side tool results
messages
Overview
GET /v1/sessions/{session_id}/messages - List messages (PRIMARY data)
POST /v1/sessions/{session_id}/messages - Create message (user message triggers workflow)
voice
Overview
create_agent_voice_session
create_call
create_client_secret
attach_call
end_call
events
Overview
GET /v1/sessions/{session_id}/events - List events (JSON)
GET /v1/sessions/{session_id}/events/summary - one-shot debug summary
GET /v1/sessions/{session_id}/sse - Stream events (SSE notifications)
providers
Overview
List all LLM providers
Create a new LLM provider
Check whether a provider accepts an API key, without storing it
GET /v1/providers/config
Get a specific LLM provider
Delete an LLM provider
Update an LLM provider
Sync models from an LLM provider
Read the owner's personal ChatGPT connection.
Disconnect the owner's ChatGPT account.
Import a private login-helper document.
Start a personal ChatGPT sign-in.
models
Overview
list_model_profiles
get_model_profile
List all models across all providers
GET /v1/models/config
get_default_decision_model
set_default_decision_model
Resolve the default for empty drafts without persisting a session.
Get a specific model with provider info and profile
Delete a model
Update a model
List models for a specific provider
Create a new model for a provider
capabilities
Overview
GET /v1/capabilities - List available capabilities with pagination
POST /v1/capabilities - Create a persisted declarative capability.
GET /v1/capabilities/declarative - List persisted declarative resources.
GET /v1/capabilities/declarative/config
GET /v1/capabilities/declarative/{capability_id} - Get a declarative resource.
DELETE /v1/capabilities/declarative/{capability_id} - Archive a declarative resource.
PATCH /v1/capabilities/declarative/{capability_id} - Update a declarative resource.
POST /v1/capabilities/declarative/{capability_id}/delete - Permanently delete archived resource.
POST /v1/capabilities/guardrails/dry-run - Evaluate guardrail checks against sample text.
GET /v1/capabilities/guardrails/examples - List adoptable guardrail presets.
GET /v1/capabilities/{capability_id} - Get a specific capability
users
Overview
GET /v1/resolve-org — resolve the owning org for a resource id.
list_mcp_connections
GET /v1/users - List users in current organization
DELETE /v1/users/me - Delete current user's account
PATCH /v1/users/me - Update current user's profile
GET /v1/users/me/export - Export current user's data
POST /v1/users/me/switch-org - Switch current organization
session-resources
Overview
List all resources registered in the session resource registry.
session-sandbox
Overview
get_sandbox
manage_sandbox
mcp-servers
Overview
GET /v1/mcp-servers - List all MCP servers
POST /v1/mcp-servers - Create a new MCP server
list_mcp_server_catalog
GET /v1/mcp-servers/config
GET /v1/mcp-servers/{server_id} - Get MCP server by ID
DELETE /v1/mcp-servers/{server_id} - Delete MCP server
PATCH /v1/mcp-servers/{server_id} - Update MCP server
get_mcp_server_usage
durable-schedules
Overview
GET /v1/durable/executions/:execution_id - Get execution details
GET /v1/durable/schedules - List schedules
POST /v1/durable/schedules - Create a new schedule
GET /v1/durable/schedules/:schedule_id - Get schedule details
DELETE /v1/durable/schedules/:schedule_id - Delete schedule
PATCH /v1/durable/schedules/:schedule_id - Update schedule
GET /v1/durable/schedules/:schedule_id/executions - List schedule executions
POST /v1/durable/schedules/:schedule_id/pause - Pause schedule
POST /v1/durable/schedules/:schedule_id/resume - Resume schedule
GET /v1/durable/schedules/:schedule_id/stats - Get schedule statistics
POST /v1/durable/schedules/:schedule_id/trigger - Manually trigger schedule
memory
Overview
list_memories
create_memory
get_memory
delete_memory
update_memory
list_root
download_action
grep_action
stat_action
get_file
update_file
create_file
delete_file
sync_memory_now
knowledge_bases
Overview
list_kbs
create_kb
get_kb
delete_kb
update_kb
list_entries
create_entry
get_entry
delete_entry
update_entry
export_okf
import_okf
knowledge_indexes
Overview
list_indexes
create_index
get_index
delete_index
update_index
list_documents
sync_index
images
Overview
GET /v1/images - List images
POST /v1/images - Upload an image
GET /v1/images/{image_id} - Get image (returns binary data)
DELETE /v1/images/{image_id} - Delete an image
GET /v1/images/{image_id}/thumbnail - Get image thumbnail
session-databases
Overview
GET /v1/sessions/{session_id}/databases
POST /v1/sessions/{session_id}/databases
GET /v1/sessions/{session_id}/databases/{name}
DELETE /v1/sessions/{session_id}/databases/{name}
GET /v1/sessions/{session_id}/databases/{name}/schema
session-storage
Overview
GET /v1/sessions/{session_id}/storage/keys - List all key-value pairs
GET /v1/sessions/{session_id}/storage/secrets - List all secrets (names only)
PUT /v1/sessions/{session_id}/storage/secrets - Batch set secrets
delete_secret
harnesses
Overview
GET /v1/harnesses
POST /v1/harnesses
GET /v1/harnesses/check-name
GET /v1/harnesses/config
POST /v1/harnesses/import - Adopt a harness example as a regular org-owned harness.
POST /v1/harnesses/preview
GET /v1/harnesses/{harness_id}
DELETE /v1/harnesses/{harness_id}
PATCH /v1/harnesses/{harness_id}
POST /v1/harnesses/{harness_id}/copy - Copy a harness
GET /v1/harnesses/{harness_id}/stats - Get aggregate usage stats for a harness
agent-triggers
Overview
list_agent_triggers
POST /v1/agents/{agent_id}/triggers
GET /v1/agents/{agent_id}/triggers/{trigger_id}
DELETE /v1/agents/{agent_id}/triggers/{trigger_id}
PATCH|PUT /v1/agents/{agent_id}/triggers/{trigger_id}
list_agent_trigger_deliveries
list_agent_trigger_runs
POST /v1/agents/{agent_id}/triggers/{trigger_id}/trigger
skills
Overview
GET /v1/skills - List all skills
POST /v1/skills - Create skill from SKILL.md
GET /v1/skills/config
POST /v1/skills/upload - Create skill from ZIP archive
GET /v1/skills/usage - Count agents/harnesses referencing each skill
POST /v1/skills/validate - Validate SKILL.md content
GET /v1/skills/{skill_id} - Get skill by ID
DELETE /v1/skills/{skill_id} - Delete skill
PATCH /v1/skills/{skill_id} - Update skill
GET /v1/skills/{skill_id}/content - Get full skill content
payments
Overview
list_payment_accounts
create_payment_account
get_payment_account
disable_payment_account
update_payment_account
list_payment_attempts
list_payment_policies
create_payment_policy
get_payment_policy
disable_payment_policy
update_payment_policy
reporting
Overview
backfill_reporting
get_diagnostics
get_catalog
run_projector
run_query
export_query
list_saved_reports
create_saved_report
get_saved_report
delete_saved_report
update_saved_report
export_saved_report
run_saved_report
commands
Overview
GET /v1/commands - List the command contract
POST /v1/commands/{name} - Run one command
task-webhooks
Overview
List all task webhooks configured for the organization.
Create a new task webhook for the organization.
Get a single task webhook.
Delete a task webhook.
Update a task webhook.
agent-examples
GET /v1/agent-examples — list all available examples
agent-channels
list_agent_channels
create_agent_channel
get_agent_channel
delete_agent_channel
update_agent_channel
publish_agent_channel
trigger_agent_channel
unpublish_agent_channel
list_agent_endpoints
create_agent_endpoint
get_agent_endpoint
delete_agent_endpoint
update_agent_endpoint
publish_agent_endpoint
trigger_agent_endpoint
unpublish_agent_endpoint
apps
list_apps
get_app
POST /v1/apps/{app_id}/a2a/{channel_id}
GET /v1/apps/{app_id}/a2a/{channel_id}/.well-known/agent-card.json
POST /v1/apps/{app_id}/api/{channel_id}/sessions
GET /v1/apps/{app_id}/api/{channel_id}/sessions/{session_id}
POST /v1/apps/{app_id}/api/{channel_id}/sessions/{session_id}/cancel
POST /v1/apps/{app_id}/api/{channel_id}/sessions/{session_id}/messages
`GET /v1/apps/{app_id}/fcp` — handshake. Always returns the same generic 404 body for unknown apps so the endpoint cannot be used to probe which app ids are real.
`POST /v1/apps/{app_id}/fcp` — text-in, text-out.
invoke_webhook_legacy
invoke_a2a_channel
agent_card_channel
message_channel
create_session_channel
get_session_channel
cancel_session_channel
post_message_channel
invoke_webhook_channel
invoke_a2a_endpoint
agent_card_endpoint
message_endpoint
create_session_endpoint
get_session_endpoint
cancel_session_endpoint
post_message_endpoint
invoke_webhook_endpoint
virtual-users
Exchange verified channel authentication for a bounded runtime credential.
List providers available to this runtime account and endpoint.
Exchange verified channel authentication for a bounded runtime credential.
List legacy credentials requiring an explicit organization destination.
Move one legacy credential into the selected organization without copying it.
List virtual users.
Create virtual user.
Read the authenticated consumer runtime account.
Update the runtime profile without changing management identity or lifecycle.
Get virtual user.
Delete virtual user.
Update virtual user.
List verified external identity bindings.
Revoke an external binding and its runtime self authority.
List connections.
Create api key connection.
Delete connection.
Start provider setup bound to the authorized virtual user.
Create a target-bound provider setup URL.
Verify connection.
Destroy virtual user.
List agent-facing preferences.
Read one agent-facing preference.
Set a bounded agent-facing preference.
Delete an agent-facing preference.
List recent sessions associated with the authorized virtual user.
durable
GET /v1/durable/circuit-breakers - List circuit breakers
GET /v1/durable/circuit-breakers/:key - Get a single circuit breaker
DELETE /v1/durable/circuit-breakers/:key - Delete/reset a circuit breaker
POST /v1/durable/circuit-breakers/:key/close - Force close a circuit breaker
POST /v1/durable/circuit-breakers/:key/open - Force open a circuit breaker
GET /v1/durable/config - Durable policy results for UI gating.
GET /v1/durable/dlq - List dead letter queue entries
POST /v1/durable/dlq/:dlq_id/retry - Retry a DLQ entry
GET /v1/durable/health - Get system health
GET /v1/durable/metrics/timeseries - Get metrics time series
GET /v1/durable/sse - Stream global durable state (SSE)
GET /v1/durable/tasks - List tasks
POST /v1/durable/tasks - Enqueue a standalone task (generic queue)
GET /v1/durable/workers - List workers
POST /v1/durable/workers/:worker_id/drain - Drain a worker
POST /v1/durable/workers/:worker_id/resume - Resume a draining worker
GET /v1/durable/workflows - List workflows
GET /v1/durable/workflows/:workflow_id - Get workflow details
POST /v1/durable/workflows/:workflow_id/cancel - Cancel a workflow
GET /v1/durable/workflows/:workflow_id/events - Get workflow events
POST /v1/durable/workflows/:workflow_id/signal - Send signal to workflow
GET /v1/durable/workflows/:workflow_id/sse - Stream workflow state (SSE)
environments
list_environment_targets
list_environments
create_environment
get_environment_definition
revise_environment
archive_environment
get_session_environment
Files
List uploaded files, newest first.
Upload a PDF file for use as model input.
Download a stored file's bytes.
Delete a stored file.
harness-examples
GET /v1/harness-examples — list all available harness examples.
health-issues
List pending operational health issues visible to the caller in the current organization.
Get current issue evidence and recovery guidance in the current organization.
Verify current installation permissions without changing provider data; requires agent management access and enforces a check cooldown.
Snooze the authenticated user's reminders for one day while keeping the shared issue pending.
organization invitations
list_my_invitations
accept_my_invitation
Organizations
GET /v1/orgs - List organizations the current user belongs to
POST /v1/orgs - Create a new organization
GET /v1/orgs/:org - Get organization details
PATCH /v1/orgs/:org - Update organization
GET /v1/orgs/{org}/feature-flags — effective flags for the organization.
PATCH /v1/orgs/{org}/feature-flags — update org opt-in (admin only).
GET /v1/orgs/{org}/feature-flags/platform — every flag, including the platform-managed ones, for the operator console.
PATCH /v1/orgs/{org}/feature-flags/platform — enrol an organization in a platform-managed feature.
GET /v1/orgs/{org}/feature-flags/settings — catalog with system/org/effective state.
POST /v1/orgs/:org/onboarding/complete - Mark the org's onboarding wizard as finished (or skipped). Idempotent: the timestamp is set only when NULL.
plugins
GET /v1/plugin_marketplaces
POST /v1/plugin_marketplaces
GET /v1/plugin_marketplaces/{id}
DELETE /v1/plugin_marketplaces/{id}
PATCH /v1/plugin_marketplaces/{id}
GET /v1/plugin_marketplaces/{id}/plugins
POST /v1/plugin_marketplaces/{id}/sync
GET /v1/plugins
POST /v1/plugins
GET /v1/plugins/{id}
DELETE /v1/plugins/{id}
PATCH /v1/plugins/{id}
POST /v1/plugins/{id}/update
Session Git
POST /v1/sessions/{session_id}/git/branches
DELETE /v1/sessions/{session_id}/git/branches/{name}
POST /v1/sessions/{session_id}/git/commit
GET /v1/sessions/{session_id}/git/diff
GET /v1/sessions/{session_id}/git/log
GET /v1/sessions/{session_id}/git/refs
session-tasks
List background tasks owned by a session.
Get one session task with its recent message thread.
Request cooperative cancellation of a session task.
Send an inbound message to a session task.
List per-task push-notification configs.
Create a per-task push-notification config.
Delete a per-task push-notification config.
List background tasks across every session in the caller's org.
workspace
list_workspaces
create_workspace
get_workspace
delete_workspace
update_workspace
workspace-filesystem
GET /v1/workspaces/{workspace_id}/fs - Workspace root listing
POST /v1/workspaces/{workspace_id}/fs/_/copy - Copy a file
GET /v1/workspaces/{workspace_id}/fs/_/download/{path} - Download raw file bytes
POST /v1/workspaces/{workspace_id}/fs/_/grep - Search files
POST /v1/workspaces/{workspace_id}/fs/_/move - Move/rename a file or directory
GET /v1/workspaces/{workspace_id}/fs/_/preview/{path} - Sandboxed HTML render
POST /v1/workspaces/{workspace_id}/fs/_/stat - File metadata
GET /v1/workspaces/{workspace_id}/fs/{path} - Read file or list directory
PUT /v1/workspaces/{workspace_id}/fs/{path} - Update file content
POST /v1/workspaces/{workspace_id}/fs/{path} - Create file or directory
DELETE /v1/workspaces/{workspace_id}/fs/{path} - Delete file or directory
GitHub
Select theme
Dark
Light
Auto
Everruns Cloud is open in early access.
Run agents without operating the platform
.
Overview
commands
Section titled “commands”
Generic command dispatch over the shared command contract
Operations
Section titled “ Operations ”
GET
/v1/commands
POST
/v1/commands/{name}